<template>
  <div class="goods-manage-wrap">
    <div class="listBox">
      <div class="listBoxTop">
        <div class="listBoxTop-left">
          <span><i class="iconfont iconshujuliebiao"></i>数据列表</span>
        </div>
        <div class="listBoxRight">
          <el-button size="small" @click="exportGoods"><i class="iconfont icondaochu" ></i>导出</el-button>
          <el-button size="small" @click="addClassify" ><i class="iconfont icontianjiashangpin"></i><span>添加</span></el-button>
        </div>
      </div>
      <el-table
        :data="tableData"
        ref="multipleTable"
        border
        style="width: 100%"
        @cell-click="cellClick"
        size="small">
        <el-table-column
          type="index"
          fixed="left"
          label="序号"
          width="55">
        </el-table-column>
        <el-table-column
          prop="no"
          label="分类编号"
          align="center">
        </el-table-column>
        <el-table-column
          label="分类名称"
          align="center">
          <template slot-scope="scope">
            <el-input    
              v-model="scope.row.classifyName.name"
              v-if="scope.row.classifyName.isEdit"
              @blur="(val)=>{goodsEdit(val,scope.row,scope.column)}"
              size="mini"
              clearable>
            </el-input>
            <el-button type="text" v-else>{{scope.row.classifyName.name}}<i class="el-icon-edit"></i></el-button>
          </template>
        </el-table-column>
        <el-table-column
          fixed="right"
          label="操作"
          align="center" min-width="150px">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click="associateGoods(scope.row)">关联商品</el-button>
            <el-button type="text" size="small" @click="deleteGoodsClassify(scope.row.id)">删除</el-button>
          </template>
        </el-table-column>
        <el-table-column
          fixed="right"
          label="展示顺序"
          align="center">
          <template slot-scope="scope">
            <div class="stort-wrap">
              <el-button type="text" size="small" v-if="scope.$index!=0" @click="ascendingSort(scope.row,scope.$index)"><i class="el-icon-caret-top"></i></el-button>
              <el-button type="text" size="small" @click="descendingSort(scope.row,scope.$index)"><i class="el-icon-caret-bottom"></i></el-button>
            </div>
          </template>
        </el-table-column>
      </el-table>
    </div>

    <el-dialog title="添加分类" :visible.sync="dialogFormVisible">
      <el-form ref="formName" :rules="rules" :model="form">
        <el-form-item label="分类名称：" prop="classifyName">
          <el-row>
            <el-col :span="8">
              <el-input v-model="form.classifyName" ></el-input>
            </el-col>
          </el-row>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取 消</el-button>
        <el-button type="primary" @click="determineAddClassify('formName')">确 定</el-button>
      </div>
    </el-dialog>

    <el-dialog :title="tipsTitle" :visible.sync="tipsDialog" width="30%" center>
      <span>{{tipsText}}</span>
      <span slot="footer" class="dialog-footer">
        <el-button @click="tipsDialog = false">取 消</el-button>
        <el-button type="primary" @click="determine">确 定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>

import {addClassify,getClassifyList,descendingSort,ascendingSort,deleteGoodsClassify} from '@/api/goodsManage/goodsManage'

export default {
  name: 'UserList',
  components: {
    
  },
  data(){
    return{
      headerData:[],
      buttonshow:0,
      isShow:false,
      tableData:[],
      classifyId:null,
      form:{
        classifyName:null
      },
      rules:{
        classifyName:[
          {required:true,message:'请输入分类名称',trigger:'blur'}
        ]
      },
      tipsTitle: null,
      tipsDialog: false,
      tipsText: null,
      dialogFormVisible:false
    }
  },
  created(){
    this.getClassifyList();
  },
  methods:{
    headerButtonClick(index,status){
      console.log(status);
    },
    getClassifyList(){
      getClassifyList().then((res)=>{
        this.tableData=res.data.items.map((item,index)=>{
          item.classifyName={
            name:item.name,
            isEdit:false
          }
          return item
        });
        if(res.code=='000000'){
          this.tableData=res.data.items;
        }
      })
    },
    showHelp(){
      this.isShow=!this.isShow;
    },
    search(){
    },
    reset(){
    },
    goodsNameRemote(){
    },
    addClassify(){
      this.dialogFormVisible=true;
    },
    determineAddClassify(){
      addClassify({
        name:this.form.classifyName
      }).then((res)=>{
        if(res){
          this.dialogFormVisible=false;
          this.getClassifyList();
          this.$message({
            type:'success',
            message:'添加成功'
          })
          this.form.classifyName=null;
        }
      })
    },
    exportGoods(){
    },
    cellClick(row, column, cell, event){
      if(column.label==='分类名称'){
        row.classifyName.isEdit=true;
      }
    },
    goodsEdit(val,row,column){
      row.classifyName.isEdit=false;
    },
    ascendingSort(row,index){
      var temp=null;
      temp=this.tableData[index];
      this.$set(this.tableData,index,this.tableData[index-1]);
      this.$set(this.tableData,index-1,temp);
      ascendingSort(row.id).then((res)=>{
        console.log(res);
        if(res.code=='000000'){

        }
      })
    },
    descendingSort(row,index){
      var temp=null;
      temp=this.tableData[index];
      this.$set(this.tableData,index,this.tableData[index+1]);
      this.$set(this.tableData,index+1,temp);
      descendingSort(row.id).then((res)=>{
        console.log(res);
        if(res.code=='000000'){

        }
      })
    },
    associateGoods(row){
      this.$router.push({
        name:'GoodsManage',
        query:{
          id:row.id,
          classifyName:row.name
        }
      })
    },
    goodsEnable(){

    },
    deleteGoodsClassify(id){
      this.tipsDialog = true;
      this.tipsTitle = "删除商品";
      this.tipsText = "确定删除该商品？"; 
      this.classifyId=id;
    },
    determine(){
      if(this.tipsTitle=='删除商品'){
        deleteGoodsClassify(this.classifyId).then((res)=>{
          console.log(res);
          if(res){
            this.tipsDialog=false;
            this.$message({
              type:'success',
              message:'删除成功'
            })
            this.getClassifyList();
          }
        })
      }
    }
  }
}
</script>

<style scoped lang='less'>
  @color:#f3f3f3;
 .goods-manage-wrap {
    width: 100%;
    box-sizing: border-box;
    .buttonBox {
      margin-top: 10px;
      text-align: left;
      .active{
      	background-color: #339999;
      	border-color: #339999;
      	color: #FFFFFF;
      }
    }
    .filterBox {
      font-size: 12px;
      background-color: #f3f3f3;
      margin-top: 10px;
      clear: both;
      border: 1px solid #e4e4e4;
      .homeBoxTop{
        height: 50px;
        display: flex;
        justify-content: space-between;
        line-height: 50px;
        padding-left: 20px;
        background-color: #f3f3f3;
        .head-left{
          display: flex;
          align-items: center;
        }
        .myicon{
          font-weight: bold;
          color:#666;
          font-size: 20px;
          line-height: 50px;
          margin-right: 5px;
        }
      }
      span {
        font-size: 14px;
        color: #303133;
      }
      .rightBox {
        float: right;
        span{
        	cursor: pointer;
        }
        .myicon{
          color: #999;
          font-size: 10px;
        }
      }
      .el-button {
        float: right;
        height: 30px;
        margin: 10px 10px 0 10px;
      }
      .homeBoxBottom {
        display: flex;
        flex-wrap: wrap;
        border-top: 1px solid #e4e4e4;
        padding-top: 10px;
        /deep/.el-row{
          /deep/.el-col{
            display: flex;
            flex-wrap: nowrap;
          }
          .span-style{
            display:inline-block;
            width:100px;
            text-align:right;
            line-height: 40px;
          }
          .el-input {
            width: 50%;
            height: 40px;
            margin-right: 10px;
            margin-bottom: 10px;
          }
          .el-select{
            width: 50%;
            height: 40px;
            margin-left: 10px;
            margin-bottom: 10px;
            .el-input {
              width: 100%;
            }
          }
          .el-autocomplete{
            width: 50%;
            height: 40px;
            .el-input {
              width: 100%;
            }
          }
        }
        .address-wrap{
          display: inline-flex;
          flex-wrap: nowrap;
          width: 80%;
          /deep/.el-select{
            width: 30%;
            .el-input{
              width: 100%;
            }
          }
        }
        .time-wrap{
          display:inline-flex;
          flex-wrap: nowrap;
          width: 100%;
          .time-title{
            width: 40%;
            display: inline-flex;
            flex-wrap: nowrap;
            /deep/.el-select{
              width: 65%;
            }
          }
          .time-box{
            width: 60%;
            height: 40px;
            display: flex;
            justify-content:flex-start;
            align-items: center;
            span{
              margin-left: 20px;
            }
            .el-date-editor{
              width: 50%;
              height: 40px;
              margin-left: 0;
              margin-bottom: 0;
            }
            .text{
              line-height: 40px;
            }
          }
        }
      }
    }
    .listBox {
      font-size: 12px;
      background-color:@color;
      border: 1px solid #e4e4e4;
      clear: both;
      margin: 10px 0 0 0;
      .listBoxTop {
        display: flex;
        justify-content: space-between;
        flex-shrink: 0;
        flex-grow: 0;
        flex-wrap: nowrap;
        .listBoxTop-left{
          margin-left: 10px;
          width: 85px;
          .myicon{
            margin-left: 20px;
            font-weight: bold;
            font-size: 20px;
          }
          span {
            margin-left: 5px;
            font-size: 14px;
            color: #303133;
            white-space: nowrap;
            line-height: 50px;
          }
        }
      }
      .listBoxRight {
        display: flex;
        justify-content: flex-end;
        flex-wrap: wrap;
        align-items: center;
        margin:0 20px 0 0;
        .el-button {
         padding: 9px 15px;
         border-radius: 3px;
         font-size: 12px;
        }
      }
      /deep/.el-table {
        margin-top: -2px;
        /deep/.warning-row {
          background: #ffc1c1;
        }
        .el-button {
          font-size: 12px;
        }
        /deep/.cell-class-name{
          .cell{
            color: red;
          }
        }
      }
    }
    .form-button-box{
        display: flex;
        margin-top: 15px;
        justify-content: space-around;
        .el-form-item__content{
          text-align: center;
        }
    }
    .block {
      margin-top: 2px;
      display: flex;
      justify-content: flex-end;
    }
    .el-table{
      .stort-wrap{
        display: flex;
        flex-direction: column;
        .el-button--small{
          padding: 0 15px;
        }
        .el-button+.el-button{
          margin: 0;
        }
      }
    }
    /deep/.el-dialog {
      .el-dialog__header {
        text-align: left;
        background-color: #f2f2f2;
      }
      .dialog-footer {
        text-align: center;
      }
    }
 }
</style> 
